﻿<Graph ClassName="ARInvoiceEntryExtIC" Source="#CDATA" IsNew="True" FileType="NewGraph">
    <CDATA name="Source"><![CDATA[using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using PX.Common;
using PX.Objects.Common;
using PX.Objects.Common.Discount;
using PX.Data;
using PX.Data.DependencyInjection;
using PX.LicensePolicy;
using PX.Objects.GL;
using PX.Objects.CM;
using PX.Objects.CS;
using PX.Objects.CR;
using PX.Objects.TX;
using PX.Objects.IN;
using PX.Objects.BQLConstants;
using PX.Objects.EP;
using PX.Objects.SO;
using PX.Objects.DR;
using PX.Objects.CA;
using PX.Objects.AP;
using SOInvoiceEntry = PX.Objects.SO.SOInvoiceEntry;
using CRLocation = PX.Objects.CR.Standalone.Location;
using PX.Objects.GL.Reclassification.UI;
using PX.Objects.AR.BQL;
using PX.Objects.Common.Extensions;
using PX.Objects.PM;
using PMBudgetLite = PX.Objects.PM.Lite.PMBudget;
using System.Text;
using PX.Objects.Common.Bql;
using PX.Objects.Common.GraphExtensions.Abstract;
using PX.Objects.Common.GraphExtensions.Abstract.DAC;
using PX.Objects.Common.GraphExtensions.Abstract.Mapping;
using PX.Objects.Extensions.CostAccrual;
using PX.Objects.GL.FinPeriods;
using PX.Data.BQL.Fluent;
using PX.Data.BQL;
using PX.Objects;
using PX.Objects.AR;

namespace PX.Objects.AR
{
    public class ARInvoiceEntryExtIC : PXGraphExtension<ARInvoiceEntry>
    {
        #region Overrides
        /*[COMMENT START]
		[DEVELOPER NAME]: JOHN COMBATE
		[DATE TIME]: 10/19/2021 5:46:17 PM
		[PURPOSE]: UPDATE CONSIGNMENT QTY'S TO VALIDATE IN AP BILLS. ONLY INCLUDE CONSIGNMENT ITEMS*/
        public delegate IEnumerable ReleaseDelegate(PXAdapter adapter);
        [PXOverride]
        public IEnumerable Release(PXAdapter adapter, ReleaseDelegate baseMethod)
        {
            PXCache cache = Base.Document.Cache;
            List<ARRegister> list = new List<ARRegister>();
            foreach (ARInvoice ardoc in adapter.Get<ARInvoice>())
            {
                Base.OnBeforeRelease(ardoc);

                if (ardoc.Hold == false && ardoc.Released == false)
                {
                    cache.MarkUpdated(ardoc);
                    list.Add(ardoc);
                }
            }
            if (list.Count == 0)
            {
                throw new PXException(Messages.Document_Status_Invalid);
            }

            Base.Save.Press();

            PXLongOperation.StartOperation(Base, delegate ()
            {
                Base.ReleaseProcess(list);

                foreach (ARRegister invoice in list)
                {
                    decimal? consignOpenQty = 0m;
                    foreach (ARTran tran in PXSelect<
                        ARTran,
                        Where<ARTran.refNbr, Equal<Required<ARTran.refNbr>>,
                            And<ARTran.tranType, Equal<Required<ARTran.tranType>>>>>
                        .Select(Base, invoice.RefNbr, invoice.DocType))
                    {
                        if (ItemClassIsIC(tran))
                        {
                            consignOpenQty += tran.Qty;
                            Base.Transactions.SetValueExt<ARTranExtIC.usrICOpenQty>(tran, tran.Qty);
                            Base.Transactions.Update(tran);
                        }
                    }
                }

                Base.Persist();
            });

            return list;
        }
        /*[COMMENT END]*/
        #endregion

        //[DEVELOPER NAME]: JOHN COMBATE [DATE TIME]: 10/13/2021 11:43:22 AM [PURPOSE]: CHECK IF ARTRAN ITEM CLASS IS CONSIGNMENT
        public bool ItemClassIsIC(ARTran tran)
        {
            bool itemClassValid = false;

            InventoryItem item = InventoryItem.PK.Find(Base, tran.InventoryID);
            if (item != null)
            {
                INItemClass itemClass = INItemClass.PK.Find(Base, item.ItemClassID);
                if (itemClass != null)
                {
                    var itemClassExt = PXCache<INItemClass>.GetExtension<INItemClassExtIC>(itemClass);

                    itemClassValid = itemClassExt.UsrICIsConsignment == true;
                }
            }

            return itemClassValid;
        }
    }
}]]></CDATA>
</Graph>